(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('three')) :
    typeof define === 'function' && define.amd ? define('@angular-three/core/loaders', ['exports', 'rxjs', 'rxjs/operators', 'three'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['angular-three'] = global['angular-three'] || {}, global['angular-three'].core = global['angular-three'].core || {}, global['angular-three'].core.loaders = {}), global.rxjs, global.rxjs.operators, global.three));
}(this, (function (exports, rxjs, operators, three) { 'use strict';

    var bufferGeometryLoader = new three.BufferGeometryLoader();
    function loadBufferGeometry(data, onLoad) {
        return rxjs.defer(function () {
            if (typeof data === 'string')
                return rxjs.from(bufferGeometryLoader.loadAsync(data));
            return rxjs.of(bufferGeometryLoader.parse(data));
        }).pipe(operators.tap(function (geometry) {
            if (onLoad)
                onLoad(geometry);
        }));
    }

    var fontLoader = new three.FontLoader();
    function loadFont(dataOrUrl, onLoad) {
        return rxjs.defer(function () {
            if (typeof dataOrUrl === 'string')
                return rxjs.from(fontLoader.loadAsync(dataOrUrl));
            return rxjs.of(fontLoader.parse(dataOrUrl));
        }).pipe(operators.tap(function (font) {
            if (onLoad) {
                onLoad(font);
            }
        }));
    }

    /**
     * Generated bundle index. Do not edit.
     */

    exports.loadBufferGeometry = loadBufferGeometry;
    exports.loadFont = loadFont;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-three-core-loaders.umd.js.map
