import type { CameraOptions, RaycasterOptions, SceneOptions, ThreeCamera } from '@angular-three/core';
import { AnimationStore, CanvasStore, DestroyedService, EventsStore, LoopService } from '@angular-three/core';
import { ElementRef, EventEmitter, NgZone, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import type { Scene, WebGLRenderer, WebGLShadowMap } from 'three';
export declare class CanvasComponent implements OnInit, OnDestroy {
    private readonly canvasStore;
    private readonly animationStore;
    private readonly eventsStore;
    private readonly loopService;
    private readonly ngZone;
    private readonly hostElement;
    private readonly renderer;
    private readonly document;
    private readonly destroyed;
    hostClass: boolean;
    set orthographic(v: boolean);
    set linear(v: boolean);
    set shadows(v: boolean | Partial<WebGLShadowMap>);
    camera?: CameraOptions;
    scene?: SceneOptions;
    raycaster?: RaycasterOptions;
    created: EventEmitter<{
        gl: WebGLRenderer;
        camera: ThreeCamera;
        scene: Scene;
    }>;
    rendererCanvas: ElementRef<HTMLCanvasElement>;
    private windowResizeListener?;
    constructor(canvasStore: CanvasStore, animationStore: AnimationStore, eventsStore: EventsStore, loopService: LoopService, ngZone: NgZone, hostElement: ElementRef<HTMLElement>, renderer: Renderer2, document: any, destroyed: DestroyedService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    private initWindowResizeListener;
    private initActiveListener;
}
