import type { AnyConstructor } from '@angular-three/core';
import { ThreeBufferGeometry } from '@angular-three/core/geometries';
import { NgZone, OnInit } from '@angular/core';
import { Curve, Vector } from 'three';
export declare abstract class ThreeCurve<TCurve extends Curve<Vector> = Curve<Vector>> implements OnInit {
    private readonly ngZone;
    private readonly geometryDirective?;
    divisions?: number;
    abstract curveType: AnyConstructor<TCurve>;
    private _extraArgs;
    protected set extraArgs(v: unknown[]);
    constructor(ngZone: NgZone, geometryDirective?: ThreeBufferGeometry<import("three").BufferGeometry> | undefined);
    private _curve?;
    ngOnInit(): void;
    get curve(): TCurve | undefined;
}
