import { ThreeObject3d } from '@angular-three/core';
import { Directive } from '@angular/core';
export class ThreeHelper extends ThreeObject3d {
    constructor() {
        super(...arguments);
        this._extraArgs = [];
    }
    set extraArgs(v) {
        this._extraArgs = v;
    }
    ngOnChanges(changes) {
        super.ngOnChanges(changes);
        if (!this.object3d) {
            this.init();
        }
    }
    ngOnInit() {
        this.init();
    }
    initObject() {
        try {
            this._helper = new this.helperType(...this._extraArgs);
        }
        catch (e) {
            console.log('Failed to initialize Helper');
        }
    }
    get object3d() {
        return this._helper;
    }
}
ThreeHelper.decorators = [
    { type: Directive }
];
//# sourceMappingURL=helper.abstract.js.map