import { ThreeObject3d } from '@angular-three/core';
import { Directive, Input } from '@angular/core';
export class ThreeLight extends ThreeObject3d {
    constructor() {
        super(...arguments);
        this._extraArgs = [];
    }
    set extraArgs(v) {
        this._extraArgs = v;
    }
    ngOnInit() {
        this.init();
    }
    initObject() {
        if (this.intensity) {
            this._extraArgs[1] = this.intensity;
        }
        this._light = new this.lightType(...this._extraArgs);
    }
    get object3d() {
        return this._light;
    }
}
ThreeLight.decorators = [
    { type: Directive }
];
ThreeLight.propDecorators = {
    intensity: [{ type: Input }]
};
//# sourceMappingURL=light.abstract.js.map