import { defer, from, of } from 'rxjs';
import { tap } from 'rxjs/operators';
import { BufferGeometryLoader } from 'three';
const bufferGeometryLoader = new BufferGeometryLoader();
export function loadBufferGeometry(data, onLoad) {
    return defer(() => {
        if (typeof data === 'string')
            return from(bufferGeometryLoader.loadAsync(data));
        return of(bufferGeometryLoader.parse(data));
    }).pipe(tap((geometry) => {
        if (onLoad)
            onLoad(geometry);
    }));
}
//# sourceMappingURL=buffer-geometry.loader.js.map