import { defer, from, of } from 'rxjs';
import { tap } from 'rxjs/operators';
import { FontLoader } from 'three';
const fontLoader = new FontLoader();
export function loadFont(dataOrUrl, onLoad) {
    return defer(() => {
        if (typeof dataOrUrl === 'string')
            return from(fontLoader.loadAsync(dataOrUrl));
        return of(fontLoader.parse(dataOrUrl));
    }).pipe(tap((font) => {
        if (onLoad) {
            onLoad(font);
        }
    }));
}
//# sourceMappingURL=font.loader.js.map