import { ThreeObject3dMaterialGeometry } from '@angular-three/core';
import { ThreeBufferGeometry } from '@angular-three/core/geometries';
import { ThreeMaterial } from '@angular-three/core/materials';
import { ContentChild, ContentChildren, Directive } from '@angular/core';
export class ThreeMesh extends ThreeObject3dMaterialGeometry {
    set materialDirectives(v) {
        if (this.material == null && v) {
            this.material =
                v.length === 1
                    ? v.first.material
                    : v.toArray().map((dir) => dir.material);
        }
    }
    set bufferGeometryDirective(v) {
        if (this.geometry == null && v) {
            this.geometry = v.bufferGeometry;
        }
    }
    get objectType() {
        return this.meshType;
    }
}
ThreeMesh.decorators = [
    { type: Directive }
];
ThreeMesh.propDecorators = {
    materialDirectives: [{ type: ContentChildren, args: [ThreeMaterial,] }],
    bufferGeometryDirective: [{ type: ContentChild, args: [ThreeBufferGeometry,] }]
};
//# sourceMappingURL=mesh.abstract.js.map