import { ThreeObject3d } from '@angular-three/core';
import { Directive, Input } from '@angular/core';
import { DynamicDrawUsage, InstancedMesh } from 'three';
import { ThreeMesh } from '../abstracts';
export class InstancedMeshDirective extends ThreeMesh {
    constructor() {
        super(...arguments);
        this.meshType = InstancedMesh;
        this.customize = () => {
            this.object3d.instanceMatrix.setUsage(DynamicDrawUsage);
        };
    }
    set args(v) {
        this.extraArgs = v;
    }
    ngOnChanges(changes) {
        this.init();
        super.ngOnChanges(changes);
    }
    canCreate() {
        return !this.object3d && this.geometry;
    }
}
InstancedMeshDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-instancedMesh',
                exportAs: 'ngtInstancedMesh',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: InstancedMeshDirective,
                    },
                ],
            },] }
];
InstancedMeshDirective.propDecorators = {
    args: [{ type: Input }]
};
//# sourceMappingURL=instanced-mesh.directive.js.map