import { ThreeObject3d } from '@angular-three/core';
import { Directive, Input } from '@angular/core';
import { SkinnedMesh } from 'three';
import { ThreeMesh } from '../abstracts';
export class SkinnedMeshDirective extends ThreeMesh {
    constructor() {
        super(...arguments);
        this.meshType = SkinnedMesh;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
SkinnedMeshDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-skinnedMesh',
                exportAs: 'ngtSkinnedMesh',
                providers: [{ provide: ThreeObject3d, useExisting: SkinnedMeshDirective }],
            },] }
];
SkinnedMeshDirective.propDecorators = {
    args: [{ type: Input }],
    bindMatrix: [{ type: Input }],
    bindMode: [{ type: Input }]
};
//# sourceMappingURL=skinned-mesh.directive.js.map