import { ThreeObject3d } from '@angular-three/core';
import { ThreeMaterial } from '@angular-three/core/materials';
import { ContentChild, Directive, Input, } from '@angular/core';
import { SpriteMaterial } from 'three';
export class ThreeSprite extends ThreeObject3d {
    ngAfterContentInit() {
        this.init();
    }
    initObject() {
        if (this.material) {
            this._sprite = new this.spriteType(this.material);
            return;
        }
        if (this.materialDirective) {
            if (this.materialDirective.material instanceof SpriteMaterial) {
                this._sprite = new this.spriteType(this.materialDirective.material);
                return;
            }
            console.warn(`Sprite can only be instantiated with SpriteMaterial`);
        }
    }
    get object3d() {
        return this._sprite;
    }
}
ThreeSprite.decorators = [
    { type: Directive }
];
ThreeSprite.propDecorators = {
    material: [{ type: Input }],
    materialDirective: [{ type: ContentChild, args: [ThreeMaterial,] }]
};
//# sourceMappingURL=sprite.abstract.js.map