import { AnimationStore } from '@angular-three/core';
import { DOCUMENT } from '@angular/common';
import { Directive, Inject } from '@angular/core';
import Stats from 'three/examples/jsm/libs/stats.module';
export class StatsDirective {
    constructor(animationStore, document) {
        this.animationStore = animationStore;
        this.document = document;
    }
    ngOnInit() {
        this.stats = Stats();
        this.document.body.appendChild(this.stats.dom);
        this.animationStore.registerAnimation(() => {
            this.stats.update();
        });
    }
    ngOnDestroy() {
        this.stats.end();
    }
}
StatsDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-stats',
                exportAs: 'ngtStats',
            },] }
];
StatsDirective.ctorParameters = () => [
    { type: AnimationStore },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
//# sourceMappingURL=stats.directive.js.map