import { CommonModule } from '@angular/common';
import { Directive, NgModule } from '@angular/core';
import { ThreeObject3d } from '@angular-three/core';
import { Group } from 'three';

class GroupDirective extends ThreeObject3d {
    ngOnInit() {
        this.init();
    }
    initObject() {
        this._group = new Group();
    }
    get object3d() {
        return this._group;
    }
}
GroupDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-group',
                exportAs: 'ngtGroup',
                providers: [{ provide: ThreeObject3d, useExisting: GroupDirective }],
            },] }
];

class ThreeGroupModule {
}
ThreeGroupModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [
                    GroupDirective
                ],
                exports: [
                    GroupDirective
                ],
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { GroupDirective, ThreeGroupModule };
//# sourceMappingURL=angular-three-core-group.js.map
