import { ThreeObject3d } from '@angular-three/core';
import { Directive, Input, NgModule } from '@angular/core';
import { ArrowHelper, AxesHelper, BoxHelper, Box3Helper, GridHelper, CameraHelper, DirectionalLightHelper, HemisphereLightHelper, PlaneHelper, PointLightHelper, PolarGridHelper, SkeletonHelper, SpotLightHelper } from 'three';
import { CommonModule } from '@angular/common';

class ThreeHelper extends ThreeObject3d {
    constructor() {
        super(...arguments);
        this._extraArgs = [];
    }
    set extraArgs(v) {
        this._extraArgs = v;
    }
    ngOnChanges(changes) {
        super.ngOnChanges(changes);
        if (!this.object3d) {
            this.init();
        }
    }
    ngOnInit() {
        this.init();
    }
    initObject() {
        try {
            this._helper = new this.helperType(...this._extraArgs);
        }
        catch (e) {
            console.log('Failed to initialize Helper');
        }
    }
    get object3d() {
        return this._helper;
    }
}
ThreeHelper.decorators = [
    { type: Directive }
];

// GENERATED
class ArrowHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = ArrowHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
ArrowHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-arrowHelper',
                exportAs: 'ngtArrowHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: ArrowHelperDirective,
                    },
                ],
            },] }
];
ArrowHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeArrowHelperModule {
}
ThreeArrowHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [ArrowHelperDirective],
                imports: [CommonModule],
                exports: [ArrowHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class AxesHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = AxesHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
AxesHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-axesHelper',
                exportAs: 'ngtAxesHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: AxesHelperDirective,
                    },
                ],
            },] }
];
AxesHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeAxesHelperModule {
}
ThreeAxesHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [AxesHelperDirective],
                imports: [CommonModule],
                exports: [AxesHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class BoxHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = BoxHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
BoxHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-boxHelper',
                exportAs: 'ngtBoxHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: BoxHelperDirective,
                    },
                ],
            },] }
];
BoxHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeBoxHelperModule {
}
ThreeBoxHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [BoxHelperDirective],
                imports: [CommonModule],
                exports: [BoxHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class Box3HelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = Box3Helper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
Box3HelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-box3Helper',
                exportAs: 'ngtBox3Helper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: Box3HelperDirective,
                    },
                ],
            },] }
];
Box3HelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeBox3HelperModule {
}
ThreeBox3HelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [Box3HelperDirective],
                imports: [CommonModule],
                exports: [Box3HelperDirective],
            },] }
];

// GENERATED

// GENERATED
class GridHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = GridHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
GridHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-gridHelper',
                exportAs: 'ngtGridHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: GridHelperDirective,
                    },
                ],
            },] }
];
GridHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeGridHelperModule {
}
ThreeGridHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [GridHelperDirective],
                imports: [CommonModule],
                exports: [GridHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class CameraHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = CameraHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
CameraHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-cameraHelper',
                exportAs: 'ngtCameraHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: CameraHelperDirective,
                    },
                ],
            },] }
];
CameraHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeCameraHelperModule {
}
ThreeCameraHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [CameraHelperDirective],
                imports: [CommonModule],
                exports: [CameraHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class DirectionalLightHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = DirectionalLightHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
DirectionalLightHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-directionalLightHelper',
                exportAs: 'ngtDirectionalLightHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: DirectionalLightHelperDirective,
                    },
                ],
            },] }
];
DirectionalLightHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeDirectionalLightHelperModule {
}
ThreeDirectionalLightHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [DirectionalLightHelperDirective],
                imports: [CommonModule],
                exports: [DirectionalLightHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class HemisphereLightHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = HemisphereLightHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
HemisphereLightHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-hemisphereLightHelper',
                exportAs: 'ngtHemisphereLightHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: HemisphereLightHelperDirective,
                    },
                ],
            },] }
];
HemisphereLightHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeHemisphereLightHelperModule {
}
ThreeHemisphereLightHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [HemisphereLightHelperDirective],
                imports: [CommonModule],
                exports: [HemisphereLightHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class PlaneHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = PlaneHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
PlaneHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-planeHelper',
                exportAs: 'ngtPlaneHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: PlaneHelperDirective,
                    },
                ],
            },] }
];
PlaneHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreePlaneHelperModule {
}
ThreePlaneHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [PlaneHelperDirective],
                imports: [CommonModule],
                exports: [PlaneHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class PointLightHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = PointLightHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
PointLightHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-pointLightHelper',
                exportAs: 'ngtPointLightHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: PointLightHelperDirective,
                    },
                ],
            },] }
];
PointLightHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreePointLightHelperModule {
}
ThreePointLightHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [PointLightHelperDirective],
                imports: [CommonModule],
                exports: [PointLightHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class PolarGridHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = PolarGridHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
PolarGridHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-polarGridHelper',
                exportAs: 'ngtPolarGridHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: PolarGridHelperDirective,
                    },
                ],
            },] }
];
PolarGridHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreePolarGridHelperModule {
}
ThreePolarGridHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [PolarGridHelperDirective],
                imports: [CommonModule],
                exports: [PolarGridHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class SkeletonHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = SkeletonHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
SkeletonHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-skeletonHelper',
                exportAs: 'ngtSkeletonHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: SkeletonHelperDirective,
                    },
                ],
            },] }
];
SkeletonHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeSkeletonHelperModule {
}
ThreeSkeletonHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [SkeletonHelperDirective],
                imports: [CommonModule],
                exports: [SkeletonHelperDirective],
            },] }
];

// GENERATED

// GENERATED
class SpotLightHelperDirective extends ThreeHelper {
    constructor() {
        super(...arguments);
        this.helperType = SpotLightHelper;
    }
    set args(v) {
        this.extraArgs = v;
    }
}
SpotLightHelperDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-spotLightHelper',
                exportAs: 'ngtSpotLightHelper',
                providers: [
                    {
                        provide: ThreeObject3d,
                        useExisting: SpotLightHelperDirective,
                    },
                ],
            },] }
];
SpotLightHelperDirective.propDecorators = {
    args: [{ type: Input }]
};

// GENERATED
class ThreeSpotLightHelperModule {
}
ThreeSpotLightHelperModule.decorators = [
    { type: NgModule, args: [{
                declarations: [SpotLightHelperDirective],
                imports: [CommonModule],
                exports: [SpotLightHelperDirective],
            },] }
];

// GENERATED

// GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { ArrowHelperDirective, AxesHelperDirective, Box3HelperDirective, BoxHelperDirective, CameraHelperDirective, DirectionalLightHelperDirective, GridHelperDirective, HemisphereLightHelperDirective, PlaneHelperDirective, PointLightHelperDirective, PolarGridHelperDirective, SkeletonHelperDirective, SpotLightHelperDirective, ThreeArrowHelperModule, ThreeAxesHelperModule, ThreeBox3HelperModule, ThreeBoxHelperModule, ThreeCameraHelperModule, ThreeDirectionalLightHelperModule, ThreeGridHelperModule, ThreeHelper, ThreeHemisphereLightHelperModule, ThreePlaneHelperModule, ThreePointLightHelperModule, ThreePolarGridHelperModule, ThreeSkeletonHelperModule, ThreeSpotLightHelperModule };
//# sourceMappingURL=angular-three-core-helpers.js.map
