import { CommonModule } from '@angular/common';
import { Directive, NgModule } from '@angular/core';
import { ThreeObject3d } from '@angular-three/core';
import { Scene } from 'three';

class SceneDirective extends ThreeObject3d {
    ngOnInit() {
        this.init();
    }
    initObject() {
        this._scene = new Scene();
    }
    get object3d() {
        return this._scene;
    }
}
SceneDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-scene',
                exportAs: 'ngtScene',
                providers: [{ provide: ThreeObject3d, useExisting: SceneDirective }],
            },] }
];

class ThreeSceneModule {
}
ThreeSceneModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [
                    SceneDirective
                ],
                exports: [
                    SceneDirective
                ],
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { SceneDirective, ThreeSceneModule };
//# sourceMappingURL=angular-three-core-scene.js.map
