import { EventEmitter, NgZone, OnDestroy } from '@angular/core';
import { AnimationStore } from '../stores';
import type { AnimationReady } from '../typings';
export declare abstract class AnimationLoopParticipant<TObject = unknown> implements OnDestroy {
    protected readonly animationStore: AnimationStore;
    protected readonly ngZone: NgZone;
    animateReady: EventEmitter<AnimationReady<TObject>>;
    private animateTeardown?;
    protected constructor(animationStore: AnimationStore, ngZone: NgZone);
    protected participate(animateObject: TObject): void;
    ngOnDestroy(): void;
}
