import { AfterContentInit } from '@angular/core';
import { BufferGeometry, Material, Object3D } from 'three';
import { AnyConstructor } from '../typings';
import { ThreeObject3d } from './object-3d.abstract';
export declare abstract class ThreeObject3dMaterialGeometry<TObject extends Object3D = Object3D> extends ThreeObject3d<TObject> implements AfterContentInit {
    abstract get objectType(): AnyConstructor<TObject>;
    geometry?: string | BufferGeometry | null;
    material?: string | string[] | Material | Material[] | null;
    morphTargetInfluences?: number[];
    morphTargetDictionary?: {
        [key: string]: number;
    };
    private _objectMaterialGeometry;
    private _extraArgs?;
    set extraArgs(v: unknown[]);
    ngAfterContentInit(): void;
    protected initObject(): void;
    protected customize?: () => void;
    protected canCreate(): boolean;
    get object3d(): TObject;
    private getMaterial;
    private getGeometry;
}
