import type { AnyConstructor } from '@angular-three/core';
import { CanvasStore, InstancesStore } from '@angular-three/core';
import { NgZone, OnDestroy, OnInit } from '@angular/core';
import { Material, MaterialParameters } from 'three';
export declare abstract class ThreeMaterial<TMaterial extends Material = Material, TMaterialParameters extends MaterialParameters = MaterialParameters> implements OnInit, OnDestroy {
    protected readonly ngZone: NgZone;
    protected readonly instancesStore: InstancesStore;
    protected readonly canvasStore: CanvasStore;
    ngtId?: string;
    set parameters(v: TMaterialParameters | undefined);
    get parameters(): TMaterialParameters | undefined;
    private _parameters?;
    constructor(ngZone: NgZone, instancesStore: InstancesStore, canvasStore: CanvasStore);
    abstract materialType: AnyConstructor<TMaterial>;
    ngOnInit(): void;
    private _material;
    get material(): TMaterial;
    private convertColorToLinear;
    ngOnDestroy(): void;
}
