import type { AnyConstructor } from '@angular-three/core';
import { NgZone, OnDestroy, OnInit } from '@angular/core';
import { Texture } from 'three';
export declare abstract class ThreeTexture<TTexture extends Texture = Texture> implements OnInit, OnDestroy {
    private readonly ngZone;
    abstract textureType: AnyConstructor<TTexture>;
    constructor(ngZone: NgZone);
    private _extraArgs;
    protected set extraArgs(v: unknown[]);
    private _texture?;
    ngOnInit(): void;
    get texture(): TTexture | undefined;
    ngOnDestroy(): void;
}
